// TaskBarProgress.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <shellapi.h>
#include <shlwapi.h>
#include <string>
#include <atlbase.h>
#include <shobjidl.h>
#include <shlobj.h>

CComPtr<ITaskbarList3> m_ptrTaskbarList3;
using namespace std;
typedef basic_string<TCHAR> tstring;



int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	SHELLEXECUTEINFO	sei;
	BOOL				ret;
	//tstring				strCaption;
	TCHAR				strTemp[_MAX_PATH];
	HWND				hWnd;
	TCHAR				*strProgress;
	int					nProgress;

	SHGetSpecialFolderPath( NULL, strTemp, CSIDL_PROGRAM_FILES, FALSE );
	_tcscat_s( strTemp, _MAX_PATH, _T("\\SlySoft\\AnyDVD\\AnyDVD.exe") );

	memset( &sei, 0, sizeof( sei ) );
	sei.cbSize = sizeof( sei );
	sei.hwnd = NULL;
	sei.nShow = SW_NORMAL;
	sei.fMask = SEE_MASK_NOCLOSEPROCESS;
	sei.lpFile = strTemp;
	sei.lpParameters = _T("-iso");
	ret = ShellExecuteEx( &sei );

	if ( !ret ) return 0;

	CoInitialize(NULL);
	HRESULT hRes = m_ptrTaskbarList3.CoCreateInstance(CLSID_TaskbarList);
	Sleep( 2000 );

	while( ( hWnd = FindWindow( _T("TRipHdForm"), NULL ) ) != NULL ) {
		GetWindowText( hWnd, strTemp, 256 );
		strProgress = _tcsrchr( strTemp, _T(' ') );
		if ( strProgress == NULL ) break;
		if ( ( _stscanf_s( strProgress, _T("%d"), &nProgress ) == 0 ) || ( nProgress == 0 ) ) {
			m_ptrTaskbarList3->SetProgressState( hWnd, TBPF_NOPROGRESS );
		}
		else {
			m_ptrTaskbarList3->SetProgressState(hWnd, TBPF_NORMAL);
			m_ptrTaskbarList3->SetProgressValue(hWnd, nProgress, 100);
		}
		Sleep( 2000 );
	}


	return 0;
}